--[[
Copyright (C) GtX (Andy), 2021

Author: GtX | Andy
Date: 08.06.2021
Revision: FS22

Contact:
https://forum.giants-software.com
https://github.com/GtX-Andy

Important:
Not to be added to any mods / maps or modified from its current release form.
No changes are to be made to this script without permission from GtX | Andy

Darf nicht zu Mods / Maps hinzugefügt oder von der aktuellen Release-Form geändert werden.
An diesem Skript dürfen ohne Genehmigung von GtX | Andy keine Änderungen vorgenommen werden
]]

RandomWrapColorsEvent = {}

local RandomWrapColorsEvent_mt = Class(RandomWrapColorsEvent, Event)
InitEventClass(RandomWrapColorsEvent, "RandomWrapColorsEvent")

function RandomWrapColorsEvent.emptyNew()
    local self = Event.new(RandomWrapColorsEvent_mt)

    return self
end

function RandomWrapColorsEvent.new(object, configId)
    local self = RandomWrapColorsEvent.emptyNew()

    self.object = object
    self.configId = configId

    return self
end

function RandomWrapColorsEvent:readStream(streamId, connection)
    self.object = NetworkUtil.readNodeObject(streamId)
    self.configId = streamReadUInt16(streamId) + 1

    self:run(connection)
end

function RandomWrapColorsEvent:writeStream(streamId, connection)
    NetworkUtil.writeNodeObject(streamId, self.object)
    streamWriteUInt16(streamId, self.configId - 1)
end

function RandomWrapColorsEvent:run(connection)
    if self.object ~= nil and self.object:getIsSynchronized() then
        self.object:updateWrappingColorConfiguration(self.configId)
    end
end
